//************************************************
// bot communications
// writen 4/18/02 by Nick Trienens
//************************************************

#include "BotCommunication.h"
#include "time.h"

//define the arrays that are needed
int   intPool[NUM_ARRAYS][32];
float floatPool[NUM_ARRAYS][32];
bool  boolPool[NUM_ARRAYS][32];
bool initalized = false;

void hivemind_init(){
	for(int i=0;i<NUM_ARRAYS;i++){
		for(int j=0;j<32;j++){
			intPool[i][j] = 0;
			floatPool[i][j] = 0;
			boolPool[i][j] = false;
		}
	}
	initalized = true;
}

void hivemind_set(int type, int number, int player_id, float value){
	if(!initalized){
		hivemind_init();
	}
	if(type == 0){
		//we have an int
		
		//check to see if the mailbox is in the array
		if(number < 0 && number > NUM_ARRAYS)
			return;

		intPool[number][player_id] = (int)value;


	}else if(type == 1){
		//we have a float

		//check to see if the mailbox is in the array
		if(number < 0 && number > NUM_ARRAYS)
			return;

		floatPool[number][player_id] = (float)value;

	}else if(type == 2){
		//we have a bool

		//check to see if the mailbox is in the array
		if(number < 0 && number > NUM_ARRAYS)
			return;

		boolPool[number][player_id] = (bool)value;
	}

}



void* hivemind_get(int type, int number){
	if(!initalized){
		hivemind_init();
	}
	if(type == 0){
		//we have an int
		
		//check to see if the mailbox is in the array
		if(number < 0 && number > NUM_ARRAYS)
			return NULL;

		return intPool[number];


	}else if(type == 1){
		//we have a float

		//check to see if the mailbox is in the array
		if(number < 0 && number > NUM_ARRAYS)
			return NULL;

		return floatPool[number];

	}else if(type == 2){
		//we have a bool

		//check to see if the mailbox is in the array
		if(number < 0 && number > NUM_ARRAYS)
			return NULL;

		return boolPool[number];
	}
	return NULL;
}