#include "extdll.h" 
#include "util.h"
#include "client.h"
#include "cbase.h"

#include "BotControl.h"
#include "ExternalBotDebug.h"
#include "SocketServer.h"
#include "Commands.h"
#include "BotTournament.h"
#include "FlexDebug.h"
#include "FlexControl.h"

extern FlexDebug * flexDebug;
extern FlexControl * flexControl;
extern SocketServer commandSocket;

double lastControllerCheckTime = 0;

/*********************************************
/ CHECK EXTERNAL CONTROLLERS
/ A place to check for external control messages
/ and handle them. Should only do work if it has
/ not been called yet on this frame cycle.
*********************************************/
void CheckExternalControllers()
{
	// This if-statement must be here to keep from checking
	// for external messages many times per frame (so that
	// each bot doesn't call it every frame -- performance hit)
	if (gpGlobals->time > lastControllerCheckTime)
	{
		// ---- FRAMEWORK FOR IMPLEMENTATION ---- //
		// Note that the code below is dummy code for the example. 
		//
		// Check for a new command from an external controller.
		// Valid commands include any console command available
		// in the FlexBot (refer to the manual). The command should
		// be passed to ProcessCommand as a char* with NULL as the
		// first argument (to indicate that it is not coming from
		// a player in the game).
		// -------------------------------------- //
		bool newCmd = FALSE;
		char * cmd = "bot add";	// example of a command
		if (newCmd)
			ProcessCommand(NULL, cmd);


		// Get any commands arriving from FlexControl modules
		if (!flexControl)
			flexControl = new FlexControl;
		flexControl->CheckForCommands();
		while (flexControl->CommandsWaiting()) {
			ProcessCommand(NULL, flexControl->GetCommand());
		}

		// ---------------------------------------//
		// PATTON command checking (Greg Dunham, Nick Trienens, Sanjay Sood, Andy Crossen, Kirk Moore)
		// ---------------------------------------//
	/*
		char pattonCmd[1000];		
		if (commandSocket.ReceiveMessage(pattonCmd)) {
			ProcessCommand(NULL, pattonCmd);
		}
	*/
		// ---------------------------------------//
	}
	else return;

	// Must be here to make last-call checking accurate
	lastControllerCheckTime = gpGlobals->time;
}

/*********************************************
/ SEND EXTERNAL DEBUG
/ Handles debug messages for bot #botNum. You can pass
/ these debug messages to any external handlers. The
/ syntax of a debug message is:
/   "signal-name value"

/ For example, if a debug message were sent for a signal
/ named "left-distance" and that value was 13, the debug
/ message would be "left-distance 13".
/
/ Parsing of the debug data must be done by the handler.
*********************************************/
void SendExternalDebug(int botNum, const char * debugMsg)
{
	// Dump the debug data to a file
//	DumpDebugSignalToFile(botNum, debugMsg);

	// Pass debug data to the BotWatch debugging tool
//	BotWatchDebug(botNum, debugMsg);

	// Give FlexDebug modules access to debug data
	if (!flexDebug) {
		flexDebug = new FlexDebug;
		flexDebug->Reset();
	}
	flexDebug->DebugMessage(botNum, debugMsg);

	// The debug data can also be passed to any other procedures...
	//   [put other debug handlers here]
}