#include "extdll.h" 
#include "util.h"
#include "cbase.h"
#include "bot.h"

/*********************************************
/ DO DEBUGGING BEAMS
/ Draws the debugging beams for center, left,
/ and right traces.
*********************************************/
void CBot::DoDebuggingBeams()
{
	if (m_bDebugOn)
	{
		if (!m_pCenterBeam && m_bUpdatingCenterBeam)
			m_pCenterBeam = InitNewDistanceBeam(255, 0, 0);
		if (!m_pRightBeam && m_bUpdatingRightBeam)
			m_pRightBeam = InitNewDistanceBeam(0, 255, 255);
		if (!m_pLeftBeam && m_bUpdatingLeftBeam)
			m_pLeftBeam = InitNewDistanceBeam(0, 255, 255);
		//m_pBeam = NULL;
	}
}

/*********************************************
/ INIT NEW DISTANCE BEAM
/ For debugging purposes: initializes the beams that are seen with
/ left, right, center distance, etc.
*********************************************/
CBeam * CBot::InitNewDistanceBeam(int rColor, int gColor, int bColor)
{
	CBeam * pBeam = CBeam::BeamCreate( "sprites/laserbeam.spr", 7 );
	pBeam->SetColor(rColor, gColor, bColor);
	pBeam->SetBrightness( 255 );
	pBeam->PointEntInit( pev->origin, entindex( ) );
	pBeam->SetEndAttachment( 1 );

	return pBeam;
}

/*********************************************
/ CLEANUP DEBUG BEAMS
/ Cleans up the remnants of debugging beams
/ when they are no longer bing used. 
*********************************************/
void CBot::CleanupDebugBeams()
{
	// Make the debugging beams go away
	if (m_pLeftBeam)
	{
		m_pLeftBeam->LiveForTime(0.01);
		m_pLeftBeam = NULL;
	}
	if (m_pRightBeam)
	{
		m_pRightBeam->LiveForTime(0.01);
		m_pRightBeam = NULL;
	}
	if (m_pCenterBeam)
	{
		m_pCenterBeam->LiveForTime(0.01);
		m_pCenterBeam = NULL;
	}

	// Don't update the debugging beams
	m_bUpdatingCenterBeam = FALSE;
	m_bUpdatingLeftBeam = FALSE;
	m_bUpdatingRightBeam = FALSE;
}

/*********************************************
/ DUMP DEBUG SIGNAL TO FILE
/ Dumps the signal to a bot's file.
*********************************************/
//void DumpDebugSignalToFile(botNum, debugMsg)
//{
//
//}