/*********************************************
/ BotMessenger.cpp
/
/ The Bot Messenger system is defined and implemented
/ here. The Bot Messenger system can be compared to a
/ post office -- it allows messages to
/ be sent at any time to any bot and later retrieved
/ by the proper bot at a convenient time. Each message
/ consists of:
/   1. Message text
/   2. Message argument
/
/ Delete should be called on a message by the user
/ after it has been retrieved and processed because 
/ messages are dynamically allocated when being placed
/ into the bot's mailbox.
*********************************************/

#include "extdll.h"
#include "BotMessenger.h"
#include "assert.h"


CBotMessenger botMessenger;

void CBotMessenger::PostBotMessage (CBotMessage * message) {
	mailboxes.push_back(message);
}

CBotMessage * CBotMessenger::GetBotMessage (int playerNum) {
	std::vector<CBotMessage*>::iterator begin, end;
	CBotMessage *temp;
	begin = mailboxes.begin();
	end = mailboxes.end();

	while (begin != end){
		CBotMessage * message = * begin;
		if (message->msgToPlayer == playerNum)
		{
			temp = *begin;
			mailboxes.erase(begin);
			return temp;
		}
		else
			++begin;
	}
	// If there is no message for the bot, return NULL
	return NULL;
}

CBotMessage::CBotMessage (int fromPlayer, int toPlayer, char * newMsgText, char * newMsgArg)
{
	msgFromPlayer = fromPlayer;
	msgToPlayer = toPlayer;
	strcpy(msgText, newMsgText);
	strcpy(msgArg, newMsgArg);
}
