#ifndef BOT_SURROUNDING_ITEMS_H
#define BOT_SURROUNDING_ITEMS_H

#define MAX_INVENTORY_SIZE 50	// max number of items to track of each type 

enum _ItemType {
	ItemTypeWeapon,
	ItemTypeAmmo,
	ItemTypeWeaponbox,
	ItemTypeLadder,
	ItemTypeHealthKit,
	ItemTypeHealthCharger,
	ItemTypeSuitCharger
};

class BotSurroundingItems {
public:
	CBaseEntity * items[MAX_INVENTORY_SIZE];
	edict_t * pEdicts[MAX_INVENTORY_SIZE];
	Vector origins[MAX_INVENTORY_SIZE];
	int numItems;

	BotSurroundingItems();
	void AddItem(CBaseEntity *);
	void ClearInventory();
	void PrintItems();
};

typedef struct {
	BotSurroundingItems weaponItems;
	BotSurroundingItems ammoItems;
	BotSurroundingItems weaponBoxItems;
	BotSurroundingItems ladderItems;
	BotSurroundingItems healthKitItems;
	BotSurroundingItems healthChargerItems;
	BotSurroundingItems suitChargerItems;
} BotSurroundings;

#endif //BOT_SURROUNDING_ITEMS_H
