#ifndef BOT_TOURNAMENT_H
#define BOT_TOURNAMENT_H

#include "TacticalAnalysis.h"
#include "SocketClient.h"
#include "SocketServer.h"

#define SCORE_KILL 0
#define SCORE_SUICIDE 1
#define SCORE_FRIENDLY 2
#define SCORE_DEATH 3
#define MAX_CLIENTS 32
#define MAX_WEAPONS_FOR_STATS 25




class BotPosStream{
public:
	int BotPoses[MAX_CLIENTS][4];
	//this is a position array contents
		//0: x coordinate
		//1: y coordinate
		//2: angle the bot is looking
		//3: life 
	bool running;
	int numBots;
	int accesses;

	//SocketClient *socket;

	//vars to be filled out by the conf file
	//bool prefsLoaded;
	//char prefServer[100];
	//char prefPort[100];

	//member functions
		
	BotPosStream();
	void LoadSettings();
	//void ConnectServer(SocketClient *socket);
	void writePos(SocketClient socket);
	void recordPos(int botNum, int botX,int botY,int botFacing, int life);
};
/*
class BotPosStream{
public:
	int BotPoses[MAX_CLIENTS][4];
	int numBots;
	int accesses;

	BotPosStream();
	void writePos();
	void recordPos(int botNum, int botX,int botY,int botZ, int life);
};
*/

class BotWeaponCounter
{
public:
	char weaponName[100];
	int kills;
	int suicides;
	int friendlyKills;

	BotWeaponCounter(const char * weaponName);
};

class BotWeaponStats {
public:
	BotWeaponCounter * weapons[MAX_WEAPONS_FOR_STATS];
	int numWeapons;

	BotWeaponStats();
	void UpdateWeaponCount(const char *, int killType);
};

class BotTacticalStats {
public:
	int killPositions[NUM_TACTICAL_HEIGHTS][NUM_TACTICAL_DISTANCES];
	
	BotTacticalStats();
};

class BotTourneyTeam {
public:
	char teamName[100];
	char behaviorName[500];
	int score;
	int kills;
	int deaths;
	int suicides;
	int friendlyKills;
	BotWeaponStats weaponStats;
	BotTacticalStats tacticalStats;
};

class BotTournament {
public:
	BotTourneyTeam team1;
	BotTourneyTeam team2;
	float nextUpdateTime;
	bool prefsLoaded;
	bool restartNotify;
	char prefFileDest[1000];
	char tourneyName[100];

	BotTournament(const char * team1Name, const char * team1Behavior,
		const char * team2Name, const char * team2Behavior);

	void LoadSettings();
	void UpdateTeamScore(const char * teamName, int scoreChangeType, int scoreChange);
	void UpdateWeaponScore(const char * teamName, const char * weaponName, int killType);
	void UpdateTacticalKills(const char * teamName, _TacticalHeightType height, _TacticalDistanceType distance);
	void DumpScoreReport();
	void WriteHtmlScoreReport(const char * filename);
};

#endif // BOT_TOURNAMENT_H