#include <windows.h>
#include "stdio.h"
#include "extdll.h"
#include "ExternalBotDebug.h"


HWND hBotDebugWnds[MAX_CLIENTS];
unsigned long botDebugSearchTimes[MAX_CLIENTS];

extern globalvars_t  *gpGlobals;

// REGISTER BOT DEBUG
// Registers the bot with the BotWatch application (if
// it is running) so that the bot will be listed in the
// menu of available debug bots
void RegisterBotDebug (int botNum)
{
	HWND hBotWatchWnd = FindWindow(NULL, "BotWatch");
	if (hBotWatchWnd != NULL)
		PostMessage(hBotWatchWnd, WM_HL_BOTSPAWN, botNum, NULL);
	//else
	//	MessageBox(NULL, "Could not find BotWatch window. Please open BotWatch for debugging info.", "BotWatch Error", MB_OK);

	// Set the debug window handle to "not found"
	hBotDebugWnds[botNum - 1] = NULL;
	botDebugSearchTimes[botNum - 1] = gpGlobals->time;
}

// FLUSH BOT DEBUG LIST
// Tells the BotWatch application to remove all entries from
// its menu (should probably be called when initializing the
// game or restarting a game/map)
void FlushBotDebugList ()
{
	HWND hBotWatchWnd = FindWindow(NULL, "BotWatch");
	if (hBotWatchWnd != NULL)
		PostMessage(hBotWatchWnd, WM_HL_FLUSHREGISTRY, NULL, NULL);
}

// SEND EXT BOT DEBUG MSG
// Sends a debugging message to the appropriate app (if running).
// In this case it is BotWatch -- it should probably be generalized.
void BotWatchDebug (int botNum, const char * debugMsg)
{
	// If it is too early to look again, then return
	if (!hBotDebugWnds[botNum - 1] && gpGlobals->time < botDebugSearchTimes[botNum - 1])
		return;
	else
	{
		// Construct the name of the window to look for
		char window_title[64];
		sprintf(window_title, "BotStatus - Bot %d", botNum);
		
		// Find the window
		hBotDebugWnds[botNum - 1] = FindWindow(NULL, window_title);
		
		// Set the new lookup time (20 seconds in the future)
		botDebugSearchTimes[botNum - 1] = gpGlobals->time + 20.0;
	}
	

	if (hBotDebugWnds[botNum - 1] != NULL)
	{
		// Create the message
		COPYDATASTRUCT cds;
		cds.dwData = 0; //reserved for later use
		cds.cbData = strlen(debugMsg)+1;
		cds.lpData = (void*) debugMsg; /* pointer to command buffer */

		// Send the message
		LRESULT result = SendMessage(hBotDebugWnds[botNum - 1], WM_COPYDATA,
										NULL, (LPARAM)&cds);
	}
}