#include "extdll.h" 
#include "util.h"
#include "cbase.h"
#include "bot.h"
#include "SocketClient.h"
#include <stdio.h>

// Helper macro for displaying errors
#define PRINTERROR(s)	\
		fprintf(stderr,"\n%: %d\n", s, WSAGetLastError())

SocketClient::SocketClient(short port_to_use) {
	
	strcpy(host, "127.0.0.1");
	port = port_to_use;
	wVersionRequested = MAKEWORD(1,1);
	socket_initialized = false;
	Init();
}

void SocketClient::SendMessage(char * msg) {
	if (!socket_initialized)
		Init();

	if (!socket_initialized) {
		//BotDebug("Socket not initialized.\n");
		return;
	}
	else {
		//
		// Send data to the server
		//
		char szBuf[256];
		
		//BotDebug("Trying to send message...\n");
		//BotDebug(msg);
		strcpy(szBuf, msg);
		int nRet = send(theSocket,				// Connected socket
			szBuf,					// Data buffer
			strlen(szBuf),			// Length of data
			0);						// Flags
		if (nRet == SOCKET_ERROR)
		{
			//PRINTERROR("send()");
			closesocket(theSocket);
			BotDebug("Socket send failed.\n");
			return;
		}
	}
	
}

void SocketClient::CloseConnection() {
	
	socket_initialized = false;
	closesocket(theSocket);
	
	//
	// Release WinSock
	//
	WSACleanup();
}

bool SocketClient::Init() {
	printf("\nClient connecting to server: %s on port: %d\n",
				host, port);

	//
	// Initialize WinSock and check the version
	//
	int nRet = WSAStartup(wVersionRequested, &wsaData);
	if (wsaData.wVersion != wVersionRequested)
	{	
		printf("\n Wrong version of Winsock.\n");
		return false;
	}

	//
	// Find the server
	//
	//printf("\nHost name is %s\n", host);
	lpHostEntry = gethostbyname(host);
    if (lpHostEntry == NULL)
    {
		printf("\nCouldn't get host by name.\n");
        PRINTERROR("gethostbyname()");
        return false;
    }

	//
	// Create a TCP/IP stream socket
	//
	theSocket = socket(AF_INET,				// Address family
					   SOCK_STREAM,			// Socket type
					   IPPROTO_TCP);		// Protocol
	if (theSocket == INVALID_SOCKET)
	{
		PRINTERROR("socket()");
		printf("\tSocket error.\n");
		return false;
	}

	//
	// Fill in the address structure
	//
	saServer.sin_family = AF_INET;
	saServer.sin_addr = *((LPIN_ADDR)*lpHostEntry->h_addr_list);
										// ^ Server's address
	saServer.sin_port = htons(port);	// Port number from command line

	//
	// connect to the server
	//
	nRet = connect(theSocket,				// Socket
				   (LPSOCKADDR)&saServer,	// Server address
				   sizeof(struct sockaddr));// Length of server address structure
	if (nRet == SOCKET_ERROR)
	{
		PRINTERROR("socket()");
		closesocket(theSocket);
		printf("\tSocket error.\n");
		return false;
	} 
	else {
		printf("\tInitialize succeeded.\n");
		socket_initialized = true;
		return true;
	}
}