#ifndef STATISTICS_H
#define STATISTICS_H

#include <string>
#include <map>

#define MAX_CLIENTS 32
#define MAX_TEAMS 32

class StatsItem {
public:
	const char * GetStat(const char *);
private:
	// std::string statName;
	// std::string statValue;
	std::map<std::string, std::string> stats;
};

class Statistics {
public:
	void UpdatePlayerStat(int, const char *, const char *);
	void UpdateTeamStat(const char *, const char *, const char *);
	void UpdateGameStat(const char *, const char *);

	const char * GetPlayerStat(int, const char *);
	const char * GetTeamStat(const char *, const char *);
	const char * GetGameStat(const char *);

private:
	StatsItem playerStats[MAX_CLIENTS];
	//std::map<std::string, StatsItem *> teamStats;
	StatsItem gameStats;
};

#endif  // STATISTICS_H