//bot.cpp========================================================
//botmans PGBot (http://planethalflife.com/botman)===============
//Bot Tutorial by BigGuy=========================================

#include "extdll.h" 
#include "util.h"
#include "client.h"
#include "cbase.h"
#include "player.h"
#include "items.h"
#include "weapons.h"
#include "soundent.h"
#include "gamerules.h"
#include "BotControl.h"
#include "BotMessenger.h"
#include "ExternalBotDebug.h"
#include "SocketClient.h"
#include "BotTournament.h"
#include "pm_debug.h"
#include "effects.h"
#include "time.h"
#include "sys/timeb.h"
#include "stdio.h"

#include "assert.h"
//These are all of the same includes from player.cpp
#include "bot.h"
#include "BotUtility.h"
#include "BotExports.h"
#include "BotTournament.h"
#include "FlexDebug.h"
#include "FlexControl.h"
#include "FlexMonitor.h"
#include "FlexStat.h"
//#include "Statistics.h"

// Support for FlexDebug modules
FlexDebug * flexDebug = NULL;

// Support for FlexControl modules
FlexControl * flexControl = NULL;

// Support for FlexMonitor modules
FlexMonitor * flexMonitor = NULL;

// Support for FlexStat modules
FlexStat * flexStat = NULL;

// Pointer to the bot that is currently thinking
extern CBot * pThinkingBot;

extern DLL_GLOBAL ULONG g_ulModelIndexPlayer;
extern DLL_GLOBAL BOOL g_fGameOver;
// Set in combat.cpp.  Used to pass the damage inflictor for death messages.
extern entvars_t *g_pevLastInflictor;

extern int gmsgHealth;
extern int gmsgCurWeapon;
extern int gmsgSetFOV;
extern int nBots;
extern std::vector<char *> bot_names_vector;

// Stat server stuff
bool stat_server_reset = false;
//extern SocketClient statSocket;
// extern SocketClient posSocket;
// The currnet tournament
BotTournament * tournament = NULL;
// BotPosStream * positions = new BotPosStream();

// Array of waypoint beams
short int numWaypointBeams = 0;
WaypointBeamMarker waypointBeams[MAX_NUM_WAYPOINTS * MAX_CLIENTS];
//infopoint beams
short int numInfopointBeams = 0;
//numInfopointBeams=0;
WaypointBeamMarker InfopointBeams[MAX_NUM_INFOPOINTS * MAX_CLIENTS];

// Keep track of how many bots still need to be added (must slightly time-delay adds)
int botsWaitingToBeAdded = 0;
double lastBotAddTime = 0;

// store the names of the models...
char *my_valve_bot_skins[] = {
   "barney", "gina", "gman", "gordon", "helmet",
   "hgrunt", "recon", "robo", "scientist", "zombie"};


int f_Observer = 0;  
// flag to indicate if we are in observer mode

LINK_ENTITY_TO_CLASS( bot, CBot );
//entity similar to player

// Just trust me on this stuff
inline edict_t *CREATE_FAKE_CLIENT( const char *netname )
{
    return (*g_engfuncs.pfnCreateFakeClient)( netname );
}
inline char *GET_INFOBUFFER( edict_t *e )
{
    return (*g_engfuncs.pfnGetInfoKeyBuffer)( e );
}
inline void SET_CLIENT_KEY_VALUE( int clientIndex, char *infobuffer, char *key, char *value )
{
    (*g_engfuncs.pfnSetClientKeyValue)( clientIndex, infobuffer, key, value );
}
// Youll need it later
//===================================================
// Heres the function you called in client.cpp
void BotCreate( void )
{
   edict_t *BotEnt;

   // Get the bot name from list
   char bot_name[120];
   strcpy(bot_name, bot_names_vector[nBots % bot_names_vector.size()]);

   BotEnt = CREATE_FAKE_CLIENT( bot_name );

   if (FNullEnt( BotEnt ))
      ALERT ( at_console, "NULL Ent in CREATE_FAKE_CLIENT!\n" );
   else
   {
      char ptr[128];  // allocate space for message from ClientConnect
      CBot *BotClass;
      char *infobuffer;
      int clientIndex;

      BotClass = GetClassPtr( (CBot *) VARS(BotEnt) );
      infobuffer = GET_INFOBUFFER( BotClass->edict( ) );
      clientIndex = BotClass->entindex( );

	  // Set some member variables for the bot
	  BotClass->playerNum = clientIndex;
	  //if (!flexStat)
	  //		flexStat = new FlexStat;
	  
      
	  // Set the bot's skin
	  SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "model", my_valve_bot_skins[nBots % 10] );

	  // Set the bot's colors
	  char colorStr[8];
	  itoa( RANDOM_LONG(0,50), colorStr, 10);
	  // SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "bottomcolor", itoa( RANDOM_LONG(0, 25000), colorStr, 10 ));
	  SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "bottomcolor", colorStr);
	  itoa( RANDOM_LONG(0,50), colorStr, 10);
	  SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "topcolor", colorStr);
	  
	  // Give the player a new name with number attached
	  sprintf(bot_name, "%s (Bot %d)", bot_name, clientIndex);
	  SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "name", bot_name);
	  
	  if (!flexStat)
	  		flexStat = new FlexStat;
	  //flexStat->AddPlayer(clientIndex);
	  flexStat->UpdatePlayerName(clientIndex, bot_name);

	  // Tag the player as a bot
	  BotClass->isBot = TRUE;
	  
	  BotClass->m_bPaused = FALSE;

	  // Register the bot with BotWatch
	  // RegisterBotDebug(clientIndex);

      ClientConnect( BotClass->edict( ), bot_name, "127.0.0.1", ptr );
      DispatchSpawn( BotClass->edict( ) );

	  nBots++;

	  /*
	  // Initialize the stat server
	  //turn this off to avoid slow down when adding a bot :safe 
	  if (!stat_server_reset) {
		  statSocket.SendMessage("gamestart\n");
		  stat_server_reset = true;
	  }
	  */

		
	  /*
	  // Get the bot team
	  char bot_team[100];
	  if (g_pGameRules->IsTeamplay())
		  strcpy(bot_team, g_pGameRules->GetTeamID(((CBasePlayer *)(BotClass))));
	  else
		  strcpy(bot_team, "none");
	  if (!flexStat)
			flexStat = new FlexStat;
	  flexStat->UpdatePlayerTeam(clientIndex, bot_team);
	  */

	  // Get the bot's behavior
	  /*char bot_behavior[100];
	  strcpy(bot_behavior, "unknown");
	  flexStat->UpdateBehavior(clientIndex, bot_behavior);
		*/

	  /* Initialize stats for FlexStat modules
	  if (!flexStat)
		  flexStat = new FlexStat;
	  flexStat->UpdatePlayerStat(clientIndex, "kills", "0");
	  flexStat->UpdatePlayerStat(clientIndex, "deaths", "0");
	  flexStat->UpdatePlayerStat(clientIndex, "suicides", "0");
	  flexStat->UpdatePlayerStat(clientIndex, "friendly_kills", "0");
	  */
	}
}
// It "creates" a bot
//===================================================
//===================================================
// Now some error handling code (Bug report)
void BotDebug( char *msg )
{
   // print out debug messages to the HUD of all players
   // this allows you to print messages from bots to your display
   // as you are playing the game.
   UTIL_ClientPrintAll( HUD_PRINTNOTIFY, msg );
   printf(msg);
}
//===================================================
//===================================================

CBot::CBot()
// The constructor
{
	// Initialize the beams
	m_pCenterBeam = NULL;
	m_pRightBeam = NULL;
	m_pLeftBeam = NULL;
	m_pBeam = NULL;
	
	// Behavior DLL stuff
	m_hInstDll = NULL;
	m_bDebugOn = TRUE;
	// m_pfnDoExternalBotThink = NULL;

	// Make the bot start out unpaused
	m_bPaused = FALSE;	

	// Load up a behavior DLL
//	if (LoadBehaviorDll("Do Nothing.dll"))
//		botTask = DLL;
//	else
		botTask = DO_NOTHING;
	
	// Don't do sensor debugging automatically
	m_bAutoSensorDebug = FALSE;

	// Init debugging beams
	m_bUpdatingCenterBeam = FALSE;
	m_bUpdatingLeftBeam = FALSE;
	m_bUpdatingRightBeam = FALSE;

	// Init waypoint info
	m_nWaypoints = 0;
	//Init infopoint info
	m_nInfopoints =0;

	// Performance metrics
	totalThinkTime = 0;
	totalThinks = 0;

	// Bot fitness statistics
	statKills = 0;
	statFriendlyKills = 0;
	statDeaths = 0;
	statSuicides = 0;
	statTimeMoving = 0;
	statTimeMovingTotal = 0;

	// Make the bot most accurate by default
	aimSkill = 100;
	nextAimErrorChange = 0.0;

	// Initialize the aim-error arrays
	for (int i = 0; i < MAX_CLIENTS; i++)
	{
		player_look_error[i] = 0.0;
		last_player_look_time[i] = -9999.0;
	}

	xError = 0.0;
	yError = 0.0;
	zError = 0.0;

	// Initialize stats variables
	lastKills = 0;
	lastFriendlyKills = 0;
	lastDeaths = 0;
	lastSuicides = 0;

	// Initialize the behavior name
	strcpy(behaviorName, "unknown");
	if (!flexStat)
			flexStat = new FlexStat;
	//flexStat->UpdateBehavior(playerNum, "unknown");
}

void CBot::Spawn( )
{
	// Use the default player spawn, but flag it as a bot
	CBasePlayer::Spawn();
	pev->flags = FL_CLIENT | FL_FAKECLIENT;

	pev->nextthink = gpGlobals->time + .1;

	// Notify BotWatch that a bot has been spawned
	SendExternalDebug(playerNum, "spawn");

	// Set the time for the initial item search (stagger according to player number)
	findItemsTime = ceil(gpGlobals->time) + ( fmod(playerNum, 10) / 10);

	// START CHASE CAM
	pChaseCam = NULL;
	pFreeCam = NULL;
	// END CHASE CAM

	// Set the think function
	//printf("start SetThink( BotThink )\n");
	SetThink( BotThink );
	//printf("stop SetThink( BotThink )\n");
}

/*********************************************
/ BOT THINK
/ Essentially the "brains" of the bot. Is called
/ every time that the bot is allowed to think
/ by the Half-Life engine.
*********************************************/
void CBot::BotThink( void )
{
	// Complete any backlogged FlexBot tasks
	CompleteBackloggedTasks();

	// Update the tournament status file if it is time
	/* if (tournament && tournament->nextUpdateTime < gpGlobals->time)
	{
		tournament->DumpScoreReport();
		tournament->nextUpdateTime = gpGlobals->time + 30.0;
	} */
	
//	positions->recordPos(playerNum,pev->origin.x,pev->origin.y,pev->v_angle.y, m_iClientHealth);
//	if(positions->accesses > positions->numBots)
//		positions->writePos(posSocket);
	
	// Update game state information for FlexMonitor modules
	UpdateFlexMonitor();

	// Check for messages from external controllers using FlexControl modules
	CheckExternalControllers();

	//check to see if any of the infopoints have expired
	checkInfopoints();

	// Make sure that we really want to think (nothing has gone horribly wrong)
	if (CheckCommonErrorConditions())
		return;

	// Handle a bot command if one is waiting
	HandleBotCommands();

	// Inventory the bot's surroundings (look for items)
	LookForItems();
	
	// Think about what to do and call the actuators
	if ( (botTask == DLL) && (!m_bPaused) )
	{
		pev->button = 0;		// Clear any button presses from the last think cycle
		pThinkingBot = this;	// Remember who is thinking (for use by external sensor calls)

		// Check the performance metrics
		long ms_before = GetSysTimeMillisec();

		// Make the bot think by calling the behavior DLL (with current game time)
		(m_pfnDoExternalBotThink)(m_behaviorInstance, floor(gpGlobals->time * 1000));
		
		// Get more performance metrics data
		long ms_after = GetSysTimeMillisec();

		// Update performance metrics info
		totalThinkTime += (ms_after - ms_before);
		totalThinks++;

		// Act based on actuator values
		do_rotation( (m_pfnGetExternalRotate)(m_behaviorInstance) );
		do_translation( (m_pfnGetExternalTranslate)(m_behaviorInstance) );
		do_strafe( (m_pfnGetExternalStrafe)(m_behaviorInstance) );
		do_pitch( (m_pfnGetExternalPitch)(m_behaviorInstance) );
		do_shoot( (m_pfnGetExternalShoot)(m_behaviorInstance) );
		do_duck( (m_pfnGetExternalDuck)(m_behaviorInstance) );
		do_jump( (m_pfnGetExternalJump)(m_behaviorInstance) );
		do_secondary( (m_pfnGetExternalSecondary)(m_behaviorInstance) );
		do_weapon( (m_pfnGetExternalWeapon)(m_behaviorInstance) );
		do_reload( (m_pfnGetExternalReload)(m_behaviorInstance) );
		do_use( (m_pfnGetExternalUse)(m_behaviorInstance) );
	}
	else  // paused or the behavior dll is invalid
	{
		f_move_speed = 0;
		f_strafe_speed = 0;
		pev->button = 0;
	}

	// Do debugging beams (so you can see where the bots are looking)
	DoDebuggingBeams();

	// Check if any stats have changed for stat server notification
	CheckStatChanges();

	// Calculate if the bot is moving and update the stats on movement
	Vector moved = pev->origin - v_prev_origin;
	if (moved.Length() >= 1)
		statTimeMoving += (gpGlobals->time - lastThinkTime);
	statTimeMovingTotal += (gpGlobals->time - lastThinkTime);
	v_prev_origin = pev->origin;		// save current position as previous
	lastThinkTime = gpGlobals->time;	// used to keep rotational speeds consistent

	// Have the engine perform the desired actions
	g_engfuncs.pfnRunPlayerMove(edict( ), pev->v_angle, f_move_speed,
								f_strafe_speed, 0, pev->button, 0, gpGlobals->frametime * 1000 );
}

void CBot::PlayerDeathThink( void )
{
	if (pev->deadflag == DEAD_DEAD)
	{
		if (g_pGameRules->FPlayerCanRespawn( this ))
		{
			 m_fDeadTime = gpGlobals->time;
			 pev->deadflag = DEAD_RESPAWNABLE;
		}
		return;
   }

	// If it is time to respawn, simulate a button press
	if (gpGlobals->time > (m_fDeadTime + 4.0))
	{
		pev->button = IN_ATTACK;
	}

	CBasePlayer::PlayerDeathThink();
}

//===================================================
//===================================================
//No editing here--I haven't taken anything out.
/*
void CBot::PlayerDeathThink( void )
{
   float flForward;

   CleanupDebugBeams();

   pev->nextthink = gpGlobals->time + 0.1;

   if (FBitSet( pev->flags, FL_ONGROUND ))
   {
      flForward = pev->velocity.Length( ) - 20;
      if (flForward <= 0)
		 pev->velocity = g_vecZero;
      else    
         pev->velocity = flForward * pev->velocity.Normalize( );
   }

   if (HasWeapons( ))
   {
/* 
we drop the guns here because weapons that have an area effect and can kill their user
will sometimes crash coming back from CBasePlayer::Killed() if they kill their owner because the
player class sometimes is freed. It's safer to manipulate the weapons once we know
we aren't calling into any of their code anymore through the player pointer.
*/
/*
      PackDeadPlayerItems( );
   }

   if (pev->modelindex && (!m_fSequenceFinished) && (pev->deadflag == DEAD_DYING))
   {
      StudioFrameAdvance( );

      m_iRespawnFrames++;
      if (m_iRespawnFrames < 60)  // animations should be no longer than this
         return;
   }

   if (pev->deadflag == DEAD_DYING)
   {
      pev->deadflag = DEAD_DEAD;
      DROP_TO_FLOOR ( ENT(pev) );  // put the body on the ground
   }
   
   StopAnimation( );

   pev->effects |= EF_NOINTERP;
   pev->framerate = 0.0;

   if (pev->deadflag == DEAD_DEAD)
   {
      if (g_pGameRules->FPlayerCanRespawn( this ))
      {
         m_fDeadTime = gpGlobals->time;
         pev->deadflag = DEAD_RESPAWNABLE;
      }
      
      return;
   }

   // check if time to respawn...
   if (gpGlobals->time > (m_fDeadTime + 5.0))
   {
      pev->button = 0;
      m_iRespawnFrames = 0;

      //ALERT( at_console, "Respawn\n" );

      respawn( pev, !(m_afPhysicsFlags & PFLAG_OBSERVER) );
	  pev->nextthink = -1;
   }
}
*/

void CBot::Killed( entvars_t *pevAttacker, int iGib)
{
	CBasePlayer::Killed(pevAttacker, iGib);
	
	// printf("start SetThink( PlayerDeathThink )\n");
	SetThink( CBot::PlayerDeathThink );
	// printf("stop SetThink( PlayerDeathThink )\n");
}


//This sets up the respawn of the bot. It removes the bots weapons also
//===================================================
//===================================================
/*
void CBot::Killed( entvars_t *pevAttacker, int iGib )
{
   // Set the think function
   printf("start CBot::Killed()\n");
   BotDebug("start CBot::Killed()\n");

   CSound *pSound;

   g_pGameRules->PlayerKilled( this, pevAttacker, g_pevLastInflictor );

   if (m_pTank != NULL)
   {
      m_pTank->Use( this, this, USE_OFF, 0 );
      m_pTank = NULL;
   }

   // this client isn't going to be thinking for a while, so reset the sound
   // until they respawn
   pSound = CSoundEnt::SoundPointerForIndex( CSoundEnt::ClientSoundIndex(edict( )) );
   {
      if (pSound)
      {
         pSound->Reset( );
      }
   }

   SetAnimation( PLAYER_DIE );
   
   pev->modelindex = g_ulModelIndexPlayer;    // don't use eyes

#if !defined(DUCKFIX)
   pev->view_ofs      = Vector( 0, 0, -8 );
#endif
   pev->deadflag      = DEAD_DYING;
   pev->solid         = SOLID_NOT;
   pev->movetype      = MOVETYPE_TOSS;
//   pev->movetype      = MOVETYPE_NONE;  // should we use this instead???

   ClearBits( pev->flags, FL_ONGROUND );

   if (pev->velocity.z < 10)
      pev->velocity.z += RANDOM_FLOAT( 0, 300 );

   // clear out the suit message cache so we don't keep chattering
   SetSuitUpdate( NULL, FALSE, 0 );

   // send "health" update message to zero
   m_iClientHealth = 0;

   MESSAGE_BEGIN( MSG_ONE, gmsgHealth, NULL, pev );
      WRITE_BYTE( m_iClientHealth );
   MESSAGE_END( );

   // Tell Ammo Hud that the player is dead
   MESSAGE_BEGIN( MSG_ONE, gmsgCurWeapon, NULL, pev );
      WRITE_BYTE( 0 );
      WRITE_BYTE( 0xFF );
      WRITE_BYTE( 0xFF );
   MESSAGE_END( );

   // reset FOV
   m_iFOV = m_iClientFOV = 0;

   MESSAGE_BEGIN( MSG_ONE, gmsgSetFOV, NULL, pev );
      WRITE_BYTE( 0 );
   MESSAGE_END( );

   if (( pev->health < -40 && iGib != GIB_NEVER ) || iGib == GIB_ALWAYS)
   {
      GibMonster( );   // This clears pev->model
   }

   DeathSound( );
   
   pev->angles.x = 0;  // don't let the player tilt
   pev->angles.z = 0;

   	// Set the think function
   printf("start SetThink( PlayerDeathThink )\n");
   BotDebug("start SetThink( PlayerDeathThink )\n");
   SetThink( PlayerDeathThink );
   printf("stop SetThink( PlayerDeathThink )\n");
   BotDebug("stop SetThink( PlayerDeathThink )\n");

   pev->nextthink = gpGlobals->time + 0.1;

   printf("stop CBot::Killed()\n");
   BotDebug("stop CBot::Killed()\n");

}
//This resets the HUD and clears a few other vars
*/

void CBot::SetActivity(int act)
{       
        int sequence = LookupActivity( act ); 
        if ( sequence != ACTIVITY_NOT_AVAILABLE )
        {
                pev->sequence = sequence;
                m_Activity = act; 
                pev->frame = 0;
                ResetSequenceInfo( );
                //m_flFrameRate = 1.0;
        }
}


/*********************************************
/ CHECK COMMON ERROR CONDITIONS
/ Checks to make sure that we really want the
/ bot to think. Returns TRUE if a condition 
/ exists that precludes thinking.
*********************************************/
bool CBot::CheckCommonErrorConditions()
{
	if (g_fGameOver)
	{
		// Unload the old behavior DLL
		// UnloadBehaviorDll();		** COMMENTED OUT BECAUSE IT CRASHES WHEN A FRAG LIMIT IS SET **
	}

   // Check if the bot was kicked
   if (pev->takedamage == DAMAGE_NO)
   {
      pev->health = 0;
      pev->deadflag = DEAD_DEAD;  // make the kicked bot be dead

	  // Finish removing the bot (hack)
	  CSound *pSound;
      pSound = CSoundEnt::SoundPointerForIndex( CSoundEnt::ClientSoundIndex( edict() ) );
      if ( pSound )
      {
         pSound->Reset();
      }
	  return TRUE;
   }

	// If the bot is not in the world (kicked, map change, etc.) remove the player
	if (!IsInWorld( ))
	{
		SetTouch( NULL );
		UTIL_Remove( this );
		return TRUE;
	}

	// If the bot is dead, then don't take up any space
	if (!IsAlive( ))
	{
		UTIL_SetSize( pev, Vector(0, 0, 0), Vector(0, 0, 0));
		return TRUE;
	}

	// Everything is OK
	return FALSE;
}


Vector CBot::GetGunPosition()
{
   return (pev->origin + pev->view_ofs);
}

/*********************************************
/ ADD WAYPOINT 
/ Adds a waypoint for one bot, the waypoint is stored
/ in a arry local to that bot only
*********************************************/
void CBot::AddWaypoint(WAYPOINT waypoint)
{
	BotWaypoint botWP;
	botWP.waypoint = waypoint;
	botWP.removed = FALSE;

	for (int j = 0; j < numWaypointBeams; j++)
	{
		if (waypointBeams[j].pDisplayBeam->pev->origin == waypoint.origin)
		{
			botWP.beamLocation = j;
			waypointBeams[j].numUsers++;

			//check for a deleted waypoint to replace
			int i;
			for(i=0; i < m_nWaypoints; i++){
				if(waypoints[i].removed == TRUE){
					waypoints[i] = botWP;
					return;
				}
			}
			if( m_nWaypoints >= MAX_NUM_WAYPOINTS)
				return;
			waypoints[m_nWaypoints] = botWP;
			++m_nWaypoints;
			return;
		}
	}

	//waypoints are blue
	waypointBeams[numWaypointBeams].pDisplayBeam = WaypointDrawBeam(waypoint.origin, waypoint.origin + Vector(0, 0, 68), 15, 0, 255, 0);
	waypointBeams[numWaypointBeams].numUsers = 1;
	botWP.beamLocation = numWaypointBeams;
	numWaypointBeams++;


	//check for a deleted waypoint to replace
	int i;
	for(i=0; i < m_nWaypoints; i++){
		if(waypoints[i].removed == TRUE){
			waypoints[i] = botWP;
			return;
		}
	}
	
	//didn't find one so add this waypoint to the list of waypoints
	waypoints[m_nWaypoints] = botWP;
	++m_nWaypoints;
}

/*********************************************
/ DEL WAYPOINT
/ Delete a waypoint from the list for a  given bot
*********************************************/
void CBot::DelWaypoint(BotWaypoint botWP)
{
	int i;
	for(i=0; i < m_nWaypoints; i++)
	{
		if(waypoints[i].waypoint.origin == botWP.waypoint.origin)
			break;
	}
	waypoints[i].removed = TRUE; //mark as unused
	waypointBeams[waypoints[i].beamLocation].numUsers--;

	if (waypointBeams[waypoints[i].beamLocation].numUsers == 0)
		waypointBeams[waypoints[i].beamLocation].pDisplayBeam->LiveForTime(0.01);; //disables moving, think, drawing....
}

/*********************************************
/ READ WAYPOINTS FROM FILE
/ Read waypoints from a file into the bot's memory.
*********************************************/
void CBot::ReadWaypointsFromFile(const char * filename)
{
	// Open the file
	FILE * waypointFile;
	char filepath[500];
	BuildModFilename(filepath, filename);

	waypointFile = fopen(filepath, "r");
	if (!waypointFile)
	{
		printf("Can't open the file %s", filename);
	}

	while (!feof(waypointFile))
	{		
		float x=0, y=0, z=0;
		int wpType=0;
		fscanf(waypointFile, "%f,%f,%f,%d\n", &x, &y, &z, &wpType);
		WAYPOINT wp;
		wp.origin = Vector(x, y, z);
		wp.type = wpType;
		AddWaypoint(wp);
	}

	// Close the file
	fclose(waypointFile);
}

/*********************************************
/ EXPORT WAYPOINTS TO FILE
/ Export the waypoints to a file.
*********************************************/
void CBot::ExportWaypointsToFile(const char * filename)
{
	// Open the file
	FILE * waypointFile;
	char filepath[500];
	BuildModFilename(filepath, filename);

	waypointFile = fopen(filepath, "w");
	if (!waypointFile)
	{
		printf("Can't open the file %s", filename);
	}

	for (int i = 0; i < m_nWaypoints; i++)
	{
		if (!waypoints[i].removed)
		{
			// write to the file
			fprintf(waypointFile, "%f,%f,%f,%d\n", waypoints[i].waypoint.origin.x, 
												 waypoints[i].waypoint.origin.y, 
												 waypoints[i].waypoint.origin.z,
												 waypoints[i].waypoint.type);
		}
	}

	// Close the file
	fclose(waypointFile);
}


/*********************************************
/ ADD INFOPOINT 
/ Adds a waypoint for one bot, the waypoint is stored
/ in a arry local to that bot only
*********************************************/
void CBot::AddInfopoint(WAYPOINT waypoint, int startingTime, int lifeTime)
{
	
	BotInfopoint botIP;// new BotInfopoint
	botIP.waypoint = waypoint;
	botIP.startTime = startingTime;
	botIP.owner = playerNum;
	botIP.lifeTime = lifeTime;
	botIP.removed = FALSE;

	m_nInfopoints++;
	//the type of this infopoint was set when the waypoint was created
	for (int j = 0; j < numInfopointBeams; j++)
	{
		if(InfopointBeams[j].pDisplayBeam)
			if (InfopointBeams[j].pDisplayBeam->pev->origin == botIP.waypoint.origin)
			{
				botIP.beamLocation = j;
				InfopointBeams[j].numUsers++; 
				
				//check for a deleted waypoint to replace
				int i;
				for(i=0; i < m_nInfopoints; i++){
					if(Infopoints[i].removed == TRUE){
						
						Infopoints[i] = botIP;
						return;
					}
				}
				if( m_nInfopoints >= MAX_NUM_INFOPOINTS)
					return;
				Infopoints[m_nInfopoints] = botIP;
				++m_nInfopoints;
				return;
			}
	}
	//infopoint beams are green
	//add a beam to the beam listing
	InfopointBeams[numInfopointBeams].pDisplayBeam = WaypointDrawBeam(waypoint.origin, waypoint.origin + Vector(0, 0, 68), 15, 0, 0, 255);
	InfopointBeams[numInfopointBeams].numUsers = 1;
	botIP.beamLocation = numInfopointBeams;
	numInfopointBeams++;
	
	//check for a deleted infopoint to replace
	int i;
	for(i=0; i < m_nInfopoints; i++){
		if(Infopoints[i].removed == TRUE)
		{
			Infopoints[i] = botIP;
			return;
		}
	}
	if( m_nInfopoints >= MAX_NUM_INFOPOINTS)
		return;
	Infopoints[m_nInfopoints] = botIP;
	++m_nInfopoints;
	return;
}
/*********************************************
/ EXPIRE INFOPOINTS 
/ deletes an infopoint for one bot, the infopoint is stored
/ in a arry local to that bot only
*********************************************/
void CBot::expireInfopoint(BotInfopoint botIP)
{
	int i;
	for(i=0; i <= m_nInfopoints; i++){
		if(Infopoints[i].waypoint.origin == botIP.waypoint.origin)
		{
			Infopoints[i].removed = TRUE;
			if(InfopointBeams[(Infopoints[i].beamLocation)].numUsers == 1){
				InfopointBeams[(Infopoints[i].beamLocation)].numUsers--;
				InfopointBeams[(Infopoints[i].beamLocation)].pDisplayBeam->MakeDormant();
				return;
			}else
				InfopointBeams[(Infopoints[i].beamLocation)].numUsers--;
		}
	}
	return;
}
 

/*********************************************
/ CHECK INFOPOINTS 
/ Adds a waypoint for one bot, the waypoint is stored
/ in a global array
*********************************************/
void CBot::checkInfopoints()
{
	int sysTime = gpGlobals->time;
	int i;
	
	for(i=0; i < m_nInfopoints; i++){
		if(Infopoints[i].removed == FALSE){
			if(sysTime - Infopoints[i].startTime > Infopoints[i].lifeTime)
				expireInfopoint(Infopoints[i]);
		}
	}
	return;
}

/*********************************************
/ FIND FIRST BOT
/ Cycles through the clients and returns a pointer
/ to the first bot that is found.
*********************************************/
CBot * FindFirstBot()
{ 
	CBasePlayer * pPlayer; 
	for (int currentPlayer = 1; currentPlayer <= gpGlobals->maxClients; currentPlayer++)
	{
		pPlayer = (CBasePlayer*)UTIL_PlayerByIndex( currentPlayer );
		if (pPlayer && pPlayer->isBot)
			break;
	}
	return (CBot *)pPlayer;
}

/*******************************************
/GET PLAYER INDEX
/a function to find a player's index number,
/the fucntion wants a pointer to the player 
/who's index will be returned
********************************************/
int GetPlayerIndex(CBasePlayer * player)
{
	CBasePlayer * posiblePlayer;
	for (int currentPlayer = 1; currentPlayer <= gpGlobals->maxClients; currentPlayer++)
	{
		posiblePlayer = (CBasePlayer*)UTIL_PlayerByIndex( currentPlayer );
		if (player == posiblePlayer)
			break;
	}
	return currentPlayer;
}

/*******************************************
/ KICK PLAYER
/ Kicks the player of the given player index
/ from the game.
********************************************/
void KickPlayer(int playerNum)
{
	// Get the player's name and build a "kick player-name" string
	CBasePlayer * pPlayer = (CBasePlayer *)UTIL_PlayerByIndex(playerNum);

	// If the player is a bot, unload its behavior
	if (pPlayer->isBot)
		((CBot*)pPlayer)->UnloadBehaviorDll();

	char cmd[100];
	sprintf(cmd, "kick \"%s\"\n", STRING(pPlayer->pev->netname));

	// Issue the "kick" command
    SERVER_COMMAND(cmd);
}

/*******************************************
/ LOOK FOR ITEMS
/ Creates an inventory of all items within
/ range of the bot.
********************************************/
void CBot::LookForItems()
{
	// printf("Bot %d Inventory:\n", playerNum);

	// Is it too soon to search for items?
	if (findItemsTime > gpGlobals->time)
		return;

	// Clear out the old surroundings knowledge
	surroundings.ammoItems.ClearInventory();
	surroundings.weaponItems.ClearInventory();
	surroundings.weaponBoxItems.ClearInventory();
	surroundings.ladderItems.ClearInventory();
	
	CBaseEntity * pEntity = NULL;
	while ((pEntity = UTIL_FindEntityInSphere( pEntity, pev->origin, 500 )) != NULL)
	{

		// Find the item name
		char item_name[40];
		strcpy(item_name, STRING(pEntity->pev->classname));

		// Don't inventory the item if the bot already has it
		int distanceToItem = DistanceToEntity(pEntity);
		if (distanceToItem == 0 || distanceToItem > 500)
			continue;

		// printf("ITEM: %s DISTANCE: %d\n", item_name, distanceToItem);

		// If the entity is a weapon
		if (strncmp("weapon_", item_name, 7) == 0)
		{
			CBasePlayerWeapon * pWeapon = (CBasePlayerWeapon *)pEntity;

			// If someone owns this weapon or it hasn't yet respawned
			if ((pWeapon->m_pPlayer) || (pWeapon->pev->effects & EF_NODRAW))
				continue;

			// Add the weapon to the inventory of surroundings
			surroundings.weaponItems.AddItem(pEntity);
		}
		// If the entity is ammo
		else if (strncmp("ammo_", item_name, 5) == 0)
		{
			CBasePlayerAmmo * pAmmo = (CBasePlayerAmmo *)pEntity;

			// Is the item is not visible (has not respawned)
			if (pAmmo->pev->effects & EF_NODRAW)
				continue;

			// Add the ammo to the inventory of surroundings
			surroundings.ammoItems.AddItem(pEntity);
		}
		// If the entity is a packed weapons box
		else if (strcmp("weaponbox", item_name) == 0)
		{
			// Is the item is not visible (has not respawned)
			if (pEntity->pev->effects & EF_NODRAW)
				continue;

			// Add the ammo to the inventory of surroundings
			surroundings.weaponBoxItems.AddItem(pEntity);
		}
		// If the entity is a health kit
		else if (strcmp("item_healthkit", item_name) == 0)
		{
			if (pEntity->pev->effects & EF_NODRAW)
				continue;

			// Add the health kit to the inventory of surroundings
			surroundings.healthKitItems.AddItem(pEntity);
		}
		// If the entity is a wall-mounted health charger
		else if (strcmp("func_healthcharger", item_name) == 0)
		{
			// Add the health kit to the inventory of surroundings
			surroundings.healthChargerItems.AddItem(pEntity);
		}
		// If the entity is a wall-mounted suit charger
		else if (strcmp("func_recharge", item_name) == 0)
		{
			// Add the health kit to the inventory of surroundings
			surroundings.suitChargerItems.AddItem(pEntity);
		}
		// If the entity is a ladder
		else if (strcmp("func_ladder", item_name) == 0)
		{
			//CBasePlayerAmmo * pAmmo = (CBasePlayerAmmo *)pEntity;

			// Is the item is not visible (has not respawned)
			//if (pAmmo->pev->effects & EF_NODRAW)
			//	continue;
			//sprintf(m_debugStr, "ladder added at: %d , %d, %d",pEntity->pev->origin.x,pEntity->pev->origin.y,pEntity->pev->origin.z);
			//BotDebug(m_debugStr);
			// Add the ammo to the inventory of surroundings
			surroundings.ladderItems.AddItem(pEntity);
		//	sprintf(m_debugStr, "number of ladders: %d\n", surroundings.ladderItems.numItems);
		//	BotDebug(m_debugStr);
		}
	}

	// Set when to search for items next
	findItemsTime = gpGlobals->time + 0.5;
	
}


// ** _SHOULD_ BE IN TacticalAnalysis.cpp, but has include problem **
_TacticalHeightType TacticalHeightDifference(CBasePlayer * pMainPlayer, 
										 CBasePlayer * pTargetPlayer)
{
	// returns Above if the player is above the target

	int heightDifference = pMainPlayer->pev->origin.z - pTargetPlayer->pev->origin.z;

	if (heightDifference > 300)
		return Above;
	else if (heightDifference < -300)
		return Below;
	else
		return Level;
}

// ** _SHOULD_ BE IN TacticalAnalysis.cpp, but has include problem **
_TacticalDistanceType TacticalDistance(CBasePlayer * pMainPlayer, 
								 CBasePlayer * pTargetPlayer)
{
	Vector toPlayer = pMainPlayer->pev->origin - pTargetPlayer->pev->origin;
	int distance = toPlayer.Length();
	
	if (distance < 250)
		return Close;
	else if (distance > 1000)
		return Far;
	else
		return Medium;
}

void CBot::CheckStatChanges() {
	if (!flexStat)
		flexStat = new FlexStat;

	char sockMsg[1000];
	char stat[50];
	if (lastKills < statKills) {
		//BotDebug("kills changed\n");
		itoa(statKills, stat, 10);
		//sprintf(sockMsg, "stat %d %s %s\n", playerNum, "kills", stat);
		//statSocket.SendMessage(sockMsg);
		flexStat->UpdatePlayerStat(playerNum, "kills", stat);
	}
	if (lastFriendlyKills < statFriendlyKills) {
		itoa(statFriendlyKills, stat, 10);
		//sprintf(sockMsg, "stat %d %s %s\n", playerNum, "friendly_kills", stat);
		//statSocket.SendMessage(sockMsg);
		flexStat->UpdatePlayerStat(playerNum, "friendly_kills", stat);
	}
	if (lastDeaths < statDeaths) {
		//BotDebug("deaths changed\n");
		itoa(statDeaths, stat, 10);
		//sprintf(sockMsg, "stat %d %s %s\n", playerNum, "deaths", stat);
		//statSocket.SendMessage(sockMsg);
		flexStat->UpdatePlayerStat(playerNum, "deaths", stat);
	}
	if (lastSuicides < statSuicides) {
		itoa(statSuicides, stat, 10);
		//sprintf(sockMsg, "stat %d %s %s\n", playerNum, "suicides", stat);
		//statSocket.SendMessage(sockMsg);
		flexStat->UpdatePlayerStat(playerNum, "deaths", stat);
	}

	// Set the new values
	lastKills = statKills;
	lastFriendlyKills = statFriendlyKills;
	lastDeaths = statDeaths;
	lastSuicides = statSuicides;
}

/*******************************************
/ UPDATE FLEX MONITOR
/ Sends the bot's state information to the
/ FlexMonitor system.
********************************************/
CBot::UpdateFlexMonitor() {
	if (!flexMonitor)
			flexMonitor = new FlexMonitor;
	flexMonitor->PlayerUpdate(playerNum, // player number
							  pev->origin.x, pev->origin.y, pev->origin.z, // position (x,y,z)
							  pev->health, // health
							  pev->v_angle.y, // facing direction
							  -pev->v_angle.x, // pitch direction (negative adjusts for engine bug)
							  m_pActiveItem->pszName()); // current weapon
}

/*******************************************
/ COMPLETE BACKLOGGED TASKS
/ Checks if any tasks that do not respond to Half-Life
/ events need to be completed.
********************************************/
void CompleteBackloggedTasks() {
	// Add a bot if there are bots waiting to be added and it has been more than one second.
	if ((botsWaitingToBeAdded > 0) && (gpGlobals->time > lastBotAddTime + 0.25)) {
		BotCreate();
		botsWaitingToBeAdded--;
		lastBotAddTime = gpGlobals->time;
	}
}