#ifndef GRL_AGENT_H
#define GRL_AGENT_H

//
// BOILERPLATE FOR COMMON CODE FOR COMPILED GRL PROGRAMS
// Fill this in as appropriate for your environment.
//

#include "stdlib.h"

#define neqP(a,b) (a != b)
#define random_integer(a) ((int)(rand()%a))
class grl_agent {
 public:
  grl_agent();
  virtual void update(int new_ms_clock) = 0;

  // FlexBot
  int rotate;
  int translate;
  int strafe;
  int pitch;
  bool shoot;
  bool duck;
  bool jump;
  bool secondary;
  int weapon;

    // FlexBot
  // -- ACTUATORS --
  void do_rotation(int);
  void do_translation(int);
  void do_strafe(int);
  void do_pitch(int);
  void do_shoot(bool);
  void do_duck(bool);
  void do_jump(bool);
  void do_secondary(bool);	
  void do_weapon(int);

 protected:
  // The GRL run-time system, such as it is.
  void update_grl_timeB(void);
  void before_signal_update(void);
  void after_signal_update(void);

  bool old_clock_valid;
  int ms_clock;
  int old_ms_clock;
  int measured_clock_period;

  // The GRL compiler needs these (sorry).
  int Ui;
  int UUtemp;


};

#endif //GRL_AGENT_H
